--- apps/app_readexten.c.orig   2009-02-17 15:41:24.000000000 -0500
+++ apps/app_readexten.c        2010-05-06 14:43:25.000000000 -0400
@@ -55,7 +55,7 @@
                                        </option>
                                        <option name="i">
                                                <para>Play <replaceable>filename</replaceable> as an indication tone from your
-                                               <filename>indications.conf</filename></para>
+                                               <filename>indications.conf</filename> as any valid tonelist as allowed for the Playtones application.</para>
                                        </option>
                                        <option name="n">
                                                <para>Read digits even if the channel is not answered.</para>
@@ -132,7 +132,6 @@
        int maxdigits = sizeof(exten) - 1;
        int timeout = 0, digit_timeout = 0, x = 0;
        char *argcopy = NULL, *status = "";
-       struct ast_tone_zone_sound *ts = NULL;
        struct ast_flags flags = {0};
 
         AST_DECLARE_APP_ARGS(arglist,
@@ -179,10 +178,6 @@
        if (digit_timeout <= 0)
                digit_timeout = chan->pbx ? chan->pbx->dtimeoutms : 5000;
 
-       if (ast_test_flag(&flags, OPT_INDICATION) && !ast_strlen_zero(arglist.filename)) {
-               ts = ast_get_indication_tone(chan->zone, arglist.filename);
-       }
-
        do {
                if (chan->_state != AST_STATE_UP) {
                        if (ast_test_flag(&flags, OPT_SKIP)) {
@@ -204,8 +199,8 @@
                ast_playtones_stop(chan);
                ast_stopstream(chan);
 
-               if (ts && ts->data[0])
-                       res = ast_playtones_start(chan, 0, ts->data, 0);
+               if (ast_test_flag(&flags, OPT_INDICATION) && !ast_strlen_zero(arglist.filename))
+                       res = ast_playtones_start(chan, 0, arglist.filename, 0);
                else if (arglist.filename)
                        res = ast_streamfile(chan, arglist.filename, chan->language);
 
@@ -251,10 +246,6 @@
                }
        } while (0);
 
-       if (ts) {
-               ts = ast_tone_zone_sound_unref(ts);
-       }
-
        pbx_builtin_setvar_helper(chan, "READEXTENSTATUS", status);
 
        return status[0] == 'H' ? -1 : 0;
